/*
 * GuiHipotecas.java
 *
 * Created on 9 de enero de 2008, 19:04
 */

package interfaz;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Vector;
import javax.imageio.ImageIO;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import uhupoly.Juego;
import uhupoly.Jugador;
import uhupoly.Propiedad;
import uhupoly.Solar;

/**
 *
 * @author  Pandre
 */
public class GuiHipotecas extends javax.swing.JDialog {
    
    Juego juego = null;
    Jugador jugador = null;
    Propiedad seleccionado = null;
    Propiedad seleccionada = null;
    
    /** Creates new form GuiHipotecas */
    public GuiHipotecas(java.awt.Frame parent, boolean modal, Juego juego) {
        super(parent, modal);
        
        this.juego = juego;
        this.jugador = juego.getJugadores().get(juego.getTurno());
        
        initComponents();
        
        jLabelInfoEdificios.setVisible(false);
        
        rellenaPropiedades();
        rellenaHipotecas();
        
        jListPropiedades.setCellRenderer(new ComplexCellRenderer());
        jListHipotecas.setCellRenderer(new ComplexCellRenderer());
        
        
    }
    
    private void rellenaPropiedades() {
  
        jListPropiedades.removeAll();

        jListPropiedades.setListData(juego.getJugadores().get(juego.getTurno()).getPropiedadesHipotecables());
        
    }
    
    private void rellenaHipotecas() {

        jListHipotecas.removeAll();

        jListHipotecas.setListData(juego.getJugadores().get(juego.getTurno()).getPropiedadesHipotecadas());
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabelImagen = new javax.swing.JLabel();
        jLabelPrecioHipotecado = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabelInfoEdificios = new javax.swing.JLabel();
        jButtonHipotecar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListPropiedades = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListHipotecas = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jLabelImagenH = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabelPrecioHipotecadoH = new javax.swing.JLabel();
        jButtonLevantarH = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jLabelIntereses = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabelTotal = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Gesti\u00f3n de hipotecas");
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("GESTI\u00d3N DE HIPOTECAS");

        jButton1.setText("Cerrar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabelImagen.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        jLabelPrecioHipotecado.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelPrecioHipotecado.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecioHipotecado.setText(" ");

        jLabel6.setText(" Valor hipotecado del terreno:");

        jLabelInfoEdificios.setForeground(new java.awt.Color(255, 0, 0));
        jLabelInfoEdificios.setText("\u00a1Vende los edificios antes para poder hipotecar!");

        jButtonHipotecar.setText("Hipotecar propiedad");
        jButtonHipotecar.setEnabled(false);
        jButtonHipotecar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonHipotecarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jLabelImagen, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabelPrecioHipotecado, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 143, Short.MAX_VALUE))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(58, Short.MAX_VALUE)
                .addComponent(jButtonHipotecar)
                .addGap(53, 53, 53))
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jLabelInfoEdificios, javax.swing.GroupLayout.DEFAULT_SIZE, 230, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelImagen, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecioHipotecado, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelInfoEdificios)
                .addGap(48, 48, 48)
                .addComponent(jButtonHipotecar)
                .addContainerGap(118, Short.MAX_VALUE))
        );

        jListPropiedades.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Art\u00edculo 1", "Art\u00edculo 2", "Art\u00edculo 3", "Art\u00edculo 4", "Art\u00edculo 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListPropiedades.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListPropiedades.setLayoutOrientation(javax.swing.JList.VERTICAL_WRAP);
        jListPropiedades.setVisibleRowCount(3);
        jListPropiedades.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jListPropiedadesValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(jListPropiedades);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 280, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE))
                .addContainerGap())
        );
        jTabbedPane1.addTab("Hipotecar propiedades", jPanel2);

        jListHipotecas.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Art\u00edculo 1", "Art\u00edculo 2", "Art\u00edculo 3", "Art\u00edculo 4", "Art\u00edculo 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListHipotecas.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jListHipotecas.setLayoutOrientation(javax.swing.JList.VERTICAL_WRAP);
        jListHipotecas.setVisibleRowCount(3);
        jListHipotecas.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jListHipotecasValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(jListHipotecas);

        jLabelImagenH.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        jLabel7.setText(" Valor hipotecado del terreno:");

        jLabelPrecioHipotecadoH.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelPrecioHipotecadoH.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecioHipotecadoH.setText(" ");

        jButtonLevantarH.setText("Levantar hipoteca");
        jButtonLevantarH.setEnabled(false);
        jButtonLevantarH.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLevantarHActionPerformed(evt);
            }
        });

        jLabel8.setText("Intereses a pagar:");

        jLabelIntereses.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelIntereses.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelIntereses.setText(" ");

        jLabel9.setText("Total a pagar:");

        jLabelTotal.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelTotal.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelTotal.setText(" ");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addComponent(jLabelImagenH, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9)
                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jLabel7)
                                .addComponent(jLabelPrecioHipotecadoH, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel8))
                        .addComponent(jLabelIntereses, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(63, Short.MAX_VALUE)
                .addComponent(jButtonLevantarH)
                .addGap(58, 58, 58))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(87, Short.MAX_VALUE)
                .addComponent(jLabelTotal, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelImagenH, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecioHipotecadoH, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelIntereses, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelTotal, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 24, Short.MAX_VALUE)
                .addComponent(jButtonLevantarH)
                .addGap(93, 93, 93))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 280, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 299, Short.MAX_VALUE))
                .addContainerGap())
        );
        jTabbedPane1.addTab("Levantar propiedad hipotecada", jPanel1);

        jTabbedPane1.getAccessibleContext().setAccessibleName("");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 551, Short.MAX_VALUE)
                    .addComponent(jLabel1)
                    .addComponent(jButton1, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 349, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonLevantarHActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLevantarHActionPerformed


        seleccionada.deshipotecar();
        
        juego.getObservador().actualizaJugador(jugador);

        rellenaPropiedades();
        rellenaHipotecas();
        
    }//GEN-LAST:event_jButtonLevantarHActionPerformed

    private void jButtonHipotecarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonHipotecarActionPerformed

        seleccionado.hipotecar();
        
        juego.getObservador().actualizaJugador(jugador);

        rellenaPropiedades();
        rellenaHipotecas();
        
    }//GEN-LAST:event_jButtonHipotecarActionPerformed

    private void jListHipotecasValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListHipotecasValueChanged

        seleccionada = (Propiedad)jListHipotecas.getSelectedValue();
        if (seleccionada == null) 
        {
            jLabelPrecioHipotecadoH.setText(" ");
            jLabelIntereses.setText(" ");
            jLabelTotal.setText(" ");
           
            jButtonLevantarH.setEnabled(false);
            jLabelImagenH.setIcon(null);
            return;
        }
            
        // ponemos la imagen seleccionada    
        jLabelImagenH.setIcon(UHUPolyCanvas.rotarImagenCasilla(seleccionada.getIdCasilla()));
        
        // mostramos los datos
        jLabelPrecioHipotecadoH.setText(seleccionada.getValorHipoteca() + "");
        jLabelIntereses.setText(seleccionada.getValorHipoteca()*0.1f + "");
        
        if (jugador.tieneEfectivo(seleccionada.getValorHipoteca() + seleccionada.getValorHipoteca()*0.1f))
        {
            jLabelTotal.setText(seleccionada.getValorHipoteca() + seleccionada.getValorHipoteca()*0.1f + "");
            jButtonLevantarH.setEnabled(true);
        } else
        {
            jLabelTotal.setText("No tienes dinero!");
            jButtonLevantarH.setEnabled(false);
        }
        
    }//GEN-LAST:event_jListHipotecasValueChanged

    private void jListPropiedadesValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jListPropiedadesValueChanged

        Solar solar;
        seleccionado = (Propiedad)jListPropiedades.getSelectedValue();
        if (seleccionado == null) 
        {
            jLabelPrecioHipotecado.setText(" ");
           
            jButtonHipotecar.setEnabled(false);
            jLabelImagen.setIcon(null);
            return;
        }

        // ponemos la imagen seleccionada    
        jLabelImagen.setIcon(UHUPolyCanvas.rotarImagenCasilla(seleccionado.getIdCasilla()));
        
        // mostramos los datos
        jLabelPrecioHipotecado.setText(seleccionado.getValorHipoteca() + "");
        
        jButtonHipotecar.setEnabled(true);
        jLabelInfoEdificios.setVisible(false);

        
    }//GEN-LAST:event_jListPropiedadesValueChanged

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        this.setVisible(false);
        dispose();
        
    }//GEN-LAST:event_jButton1ActionPerformed
    
    
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonHipotecar;
    private javax.swing.JButton jButtonLevantarH;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelImagen;
    private javax.swing.JLabel jLabelImagenH;
    private javax.swing.JLabel jLabelInfoEdificios;
    private javax.swing.JLabel jLabelIntereses;
    private javax.swing.JLabel jLabelPrecioHipotecado;
    private javax.swing.JLabel jLabelPrecioHipotecadoH;
    private javax.swing.JLabel jLabelTotal;
    private javax.swing.JList jListHipotecas;
    private javax.swing.JList jListPropiedades;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    // Fin de declaracin de variables//GEN-END:variables
    
    
    class ComplexCellRenderer implements ListCellRenderer {
    protected DefaultListCellRenderer defaultRenderer = new DefaultListCellRenderer();

    public Component getListCellRendererComponent(JList list, Object value, int index,
        boolean isSelected, boolean cellHasFocus) {

        JLabel renderer = (JLabel) defaultRenderer.getListCellRendererComponent(list, value, index,
            isSelected, cellHasFocus);
        
        renderer.setHorizontalAlignment(renderer.CENTER);
        renderer.setVerticalAlignment(renderer.CENTER);
        

        if (value instanceof Propiedad) {

            renderer.setIcon(UHUPolyCanvas.rotarImagenCasilla(((Propiedad)value).getIdCasilla()));
 
            renderer.setText("");
            renderer.setPreferredSize(new Dimension(90, 92));

        } 

        return renderer;
     }
    
    
    }
}
