/*
 * GuiSubastaPropiedad.java
 *
 * Created on 5 de enero de 2008, 22:12
 */

package interfaz;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.text.Format;
import java.text.NumberFormat;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import uhupoly.Casilla;
import uhupoly.Juego;
import uhupoly.Jugador;
import uhupoly.Propiedad;

/**
 *
 * @author  Pandre
 */
public class GuiSubastaPropiedad extends javax.swing.JDialog {
    
    Propiedad casilla;
    Juego juego;
    
    int numJugadorGanador;
    float puja = 30f;
    
    
    /** Creates new form GuiSubastaPropiedad */
    public GuiSubastaPropiedad(java.awt.Frame parent, boolean modal, Casilla casilla, Juego juego) {
        super(parent, modal);
        
        this.casilla = ((Propiedad)casilla);
        this.juego = juego;
        
        initComponents();
        
        jLabelPrecio.setText(this.casilla.getPrecio() + "");

        jLabelIcono.setIcon(UHUPolyCanvas.rotarImagenCasilla(casilla.getIdCasilla()));
        
        // inicializar los botones
        
        jLabelJugador3.setVisible(false);
        jButton100J3.setVisible(false);
        jButton10J3.setVisible(false);
        jButton1J3.setVisible(false);
        jLabelJugador4.setVisible(false);
        jButton100J4.setVisible(false);
        jButton10J4.setVisible(false);
        jButton1J4.setVisible(false);
        jLabelJugador5.setVisible(false);
        jButton100J5.setVisible(false);
        jButton10J5.setVisible(false);
        jButton1J5.setVisible(false);
        jLabelJugador6.setVisible(false);
        jButton100J6.setVisible(false);
        jButton10J6.setVisible(false);
        jButton1J6.setVisible(false);
        
        switch (juego.getJugadores().size()) {
                    case 6: {
                        jLabelJugador6.setText(juego.getJugadores().get(5).getNombre());
                        jLabelJugador6.setVisible(true);
                        jButton100J6.setVisible(true);
                        jButton10J6.setVisible(true);
                        jButton1J6.setVisible(true);
                        jLabelJugador6.setFont(new Font("Tahoma",Font.PLAIN,11));
                        if (juego.getJugadores().get(5).getArruinado())
                        {
                            jButton100J6.setEnabled(false);
                            jButton10J6.setEnabled(false);
                            jButton1J6.setEnabled(false);
                        }
                    }
                    case 5: {
                        jLabelJugador5.setText(juego.getJugadores().get(4).getNombre());
                        jLabelJugador5.setVisible(true);
                        jButton100J5.setVisible(true);
                        jButton10J5.setVisible(true);
                        jButton1J5.setVisible(true);
                        jLabelJugador5.setFont(new Font("Tahoma",Font.PLAIN,11));
                        if (juego.getJugadores().get(4).getArruinado())
                        {
                            jButton100J5.setEnabled(false);
                            jButton10J5.setEnabled(false);
                            jButton1J5.setEnabled(false);
                        }        
                    }
                    case 4: {
                        jLabelJugador4.setText(juego.getJugadores().get(3).getNombre());
                        jLabelJugador4.setVisible(true);
                        jButton100J4.setVisible(true);
                        jButton10J4.setVisible(true);
                        jButton1J4.setVisible(true);
                        jLabelJugador4.setFont(new Font("Tahoma",Font.PLAIN,11));
                        if (juego.getJugadores().get(3).getArruinado())
                        {
                            jButton100J4.setEnabled(false);
                            jButton10J4.setEnabled(false);
                            jButton1J4.setEnabled(false);
                        }        
                    }
                    case 3: {
                        jLabelJugador3.setText(juego.getJugadores().get(2).getNombre());
                        jLabelJugador3.setVisible(true);
                        jButton100J3.setVisible(true);
                        jButton10J3.setVisible(true);
                        jButton1J3.setVisible(true);
                        jLabelJugador3.setFont(new Font("Tahoma",Font.PLAIN,11));
                        if (juego.getJugadores().get(2).getArruinado())
                        {
                            jButton100J3.setEnabled(false);
                            jButton10J3.setEnabled(false);
                            jButton1J3.setEnabled(false);
                        }        
                    }
                    default:
                    {
                    
                        jLabelJugador2.setText(juego.getJugadores().get(1).getNombre());
                        jLabelJugador1.setText(juego.getJugadores().get(0).getNombre());
                        jLabelJugador1.setFont(new Font("Tahoma",Font.PLAIN,11));
                        jLabelJugador2.setFont(new Font("Tahoma",Font.PLAIN,11));
                        
                        if (juego.getJugadores().get(1).getArruinado())
                        {
                            jButton100J2.setEnabled(false);
                            jButton10J2.setEnabled(false);
                            jButton1J2.setEnabled(false);
                        }
                        if (juego.getJugadores().get(0).getArruinado())
                        {
                            jButton100J1.setEnabled(false);
                            jButton10J1.setEnabled(false);
                            jButton1J1.setEnabled(false);
                        }
                    }
                }
        
        setPujaJugador(-1, 0f);
        
    }
    
    private void setPujaJugador(int numJugador, float cantidad) {
    
        if ((numJugador >= 0) && (!juego.getJugadores().get(numJugador - 1).tieneEfectivo(puja + cantidad)))
        {
            JOptionPane.showMessageDialog(null, "No tienes suficiente dinero para hacer esa puja!\n", "No puedes pujar por tanto", JOptionPane.PLAIN_MESSAGE );
            return;
        }

        puja += cantidad;
        
        switch (numJugadorGanador) {
            case 1: jLabelJugador1.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador1.setForeground(Color.BLACK);
                    break;
            case 2: jLabelJugador2.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador2.setForeground(Color.BLACK);
                    break;
            case 3: jLabelJugador3.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador3.setForeground(Color.BLACK);
                    break;
            case 4: jLabelJugador4.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador4.setForeground(Color.BLACK);
                    break;
            case 5: jLabelJugador5.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador5.setForeground(Color.BLACK);
                    break;
            case 6: jLabelJugador6.setFont(new Font("Tahoma",Font.PLAIN,11)); 
                    jLabelJugador6.setForeground(Color.BLACK);
                    break;
        }
        numJugadorGanador = numJugador;
        switch (numJugadorGanador) {
            case 1: jLabelJugador1.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador1.setForeground(Color.BLUE);
                    break;
            case 2: jLabelJugador2.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador2.setForeground(Color.BLUE);
                    break;
            case 3: jLabelJugador3.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador3.setForeground(Color.BLUE);
                    break;
            case 4: jLabelJugador4.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador4.setForeground(Color.BLUE);
                    break;
            case 5: jLabelJugador5.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador5.setForeground(Color.BLUE);
                    break;
            case 6: jLabelJugador6.setFont(new Font("Tahoma",Font.BOLD,15)); 
                    jLabelJugador6.setForeground(Color.BLUE);
                    break;
        }
        jLabelPuja.setText(puja + "");
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel1 = new javax.swing.JLabel();
        jLabelIcono = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabelPrecio = new javax.swing.JLabel();
        jButtonTerminarSubasta = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabelJugador1 = new javax.swing.JLabel();
        jLabelJugador2 = new javax.swing.JLabel();
        jLabelJugador3 = new javax.swing.JLabel();
        jLabelJugador4 = new javax.swing.JLabel();
        jLabelJugador5 = new javax.swing.JLabel();
        jLabelJugador6 = new javax.swing.JLabel();
        jButton100J1 = new javax.swing.JButton();
        jButton10J1 = new javax.swing.JButton();
        jButton1J1 = new javax.swing.JButton();
        jButton100J2 = new javax.swing.JButton();
        jButton100J3 = new javax.swing.JButton();
        jButton100J4 = new javax.swing.JButton();
        jButton100J5 = new javax.swing.JButton();
        jButton100J6 = new javax.swing.JButton();
        jButton10J2 = new javax.swing.JButton();
        jButton10J3 = new javax.swing.JButton();
        jButton10J4 = new javax.swing.JButton();
        jButton10J5 = new javax.swing.JButton();
        jButton10J6 = new javax.swing.JButton();
        jButton1J2 = new javax.swing.JButton();
        jButton1J3 = new javax.swing.JButton();
        jButton1J4 = new javax.swing.JButton();
        jButton1J5 = new javax.swing.JButton();
        jButton1J6 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabelPuja = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Subastar propiedad");
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18));
        jLabel1.setText("SUBASTAR PROPIEDAD");

        jLabelIcono.setIcon(new javax.swing.ImageIcon("res\\casilla12.png"));

        jLabel2.setText("Precio de la propiedad:");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabelPrecio.setFont(new java.awt.Font("Tahoma", 1, 24));
        jLabelPrecio.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPrecio.setText("160\u20ac");
        jLabelPrecio.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jButtonTerminarSubasta.setText("Finalizar subasta");
        jButtonTerminarSubasta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTerminarSubastaActionPerformed(evt);
            }
        });

        jLabelJugador1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador1.setText("jLabel3");

        jLabelJugador2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador2.setText("jLabel3");

        jLabelJugador3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador3.setText("jLabel3");

        jLabelJugador4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador4.setText("jLabel3");

        jLabelJugador5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador5.setText("jLabel3");

        jLabelJugador6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelJugador6.setText("jLabel3");

        jButton100J1.setText("+100");
        jButton100J1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J1ActionPerformed(evt);
            }
        });

        jButton10J1.setText("+10");
        jButton10J1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J1ActionPerformed(evt);
            }
        });

        jButton1J1.setText("+1");
        jButton1J1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J1ActionPerformed(evt);
            }
        });

        jButton100J2.setText("+100");
        jButton100J2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J2ActionPerformed(evt);
            }
        });

        jButton100J3.setText("+100");
        jButton100J3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J3ActionPerformed(evt);
            }
        });

        jButton100J4.setText("+100");
        jButton100J4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J4ActionPerformed(evt);
            }
        });

        jButton100J5.setText("+100");
        jButton100J5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J5ActionPerformed(evt);
            }
        });

        jButton100J6.setText("+100");
        jButton100J6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton100J6ActionPerformed(evt);
            }
        });

        jButton10J2.setText("+10");
        jButton10J2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J2ActionPerformed(evt);
            }
        });

        jButton10J3.setText("+10");
        jButton10J3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J3ActionPerformed(evt);
            }
        });

        jButton10J4.setText("+10");
        jButton10J4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J4ActionPerformed(evt);
            }
        });

        jButton10J5.setText("+10");
        jButton10J5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J5ActionPerformed(evt);
            }
        });

        jButton10J6.setText("+10");
        jButton10J6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10J6ActionPerformed(evt);
            }
        });

        jButton1J2.setText("+1");
        jButton1J2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J2ActionPerformed(evt);
            }
        });

        jButton1J3.setText("+1");
        jButton1J3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J3ActionPerformed(evt);
            }
        });

        jButton1J4.setText("+1");
        jButton1J4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J4ActionPerformed(evt);
            }
        });

        jButton1J5.setText("+1");
        jButton1J5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J5ActionPerformed(evt);
            }
        });

        jButton1J6.setText("+1");
        jButton1J6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1J6ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabelJugador1, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton100J1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton10J1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1J1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabelJugador6, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton100J6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton10J6, 0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabelJugador5, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton100J5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton10J5, 0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabelJugador4, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton100J4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton10J4, 0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabelJugador3, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton100J3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton10J3, 0, 0, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabelJugador2, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton100J2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButton10J2)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton1J6)
                            .addComponent(jButton1J5)
                            .addComponent(jButton1J4)
                            .addComponent(jButton1J3)
                            .addComponent(jButton1J2, 0, 0, Short.MAX_VALUE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador1)
                    .addComponent(jButton100J1)
                    .addComponent(jButton10J1)
                    .addComponent(jButton1J1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador2)
                    .addComponent(jButton100J2)
                    .addComponent(jButton10J2)
                    .addComponent(jButton1J2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador3)
                    .addComponent(jButton100J3)
                    .addComponent(jButton10J3)
                    .addComponent(jButton1J3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador4)
                    .addComponent(jButton100J4)
                    .addComponent(jButton10J4)
                    .addComponent(jButton1J4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador5)
                    .addComponent(jButton100J5)
                    .addComponent(jButton10J5)
                    .addComponent(jButton1J5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelJugador6)
                    .addComponent(jButton100J6)
                    .addComponent(jButton10J6)
                    .addComponent(jButton1J6))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel6.setText("Puja actual:");
        jLabel6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabelPuja.setFont(new java.awt.Font("Tahoma", 1, 24));
        jLabelPuja.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelPuja.setText("50\u20ac");
        jLabelPuja.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabelPrecio, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelIcono, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelPuja, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(329, Short.MAX_VALUE)
                .addComponent(jButtonTerminarSubasta)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonTerminarSubasta))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabelIcono, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPrecio)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelPuja)))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1J6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J6ActionPerformed
        setPujaJugador(6, 1f);
    }//GEN-LAST:event_jButton1J6ActionPerformed

    private void jButton1J5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J5ActionPerformed
        setPujaJugador(5, 1f);
    }//GEN-LAST:event_jButton1J5ActionPerformed

    private void jButton1J4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J4ActionPerformed
        setPujaJugador(4, 1f);
    }//GEN-LAST:event_jButton1J4ActionPerformed

    private void jButton1J3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J3ActionPerformed
        setPujaJugador(3, 1f);
    }//GEN-LAST:event_jButton1J3ActionPerformed

    private void jButton1J2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J2ActionPerformed
        setPujaJugador(2, 1f);
    }//GEN-LAST:event_jButton1J2ActionPerformed

    private void jButton1J1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1J1ActionPerformed
        setPujaJugador(1, 1f);
    }//GEN-LAST:event_jButton1J1ActionPerformed

    private void jButton10J6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J6ActionPerformed
        setPujaJugador(6, 10f);
    }//GEN-LAST:event_jButton10J6ActionPerformed

    private void jButton10J5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J5ActionPerformed
        setPujaJugador(5, 10f);
    }//GEN-LAST:event_jButton10J5ActionPerformed

    private void jButton10J4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J4ActionPerformed
        setPujaJugador(4, 10f);
    }//GEN-LAST:event_jButton10J4ActionPerformed

    private void jButton10J3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J3ActionPerformed
        setPujaJugador(3, 10f);
    }//GEN-LAST:event_jButton10J3ActionPerformed

    private void jButton10J2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J2ActionPerformed
        setPujaJugador(2, 10f);
    }//GEN-LAST:event_jButton10J2ActionPerformed

    private void jButton10J1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10J1ActionPerformed
        setPujaJugador(1, 10f);
    }//GEN-LAST:event_jButton10J1ActionPerformed

    private void jButton100J6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J6ActionPerformed
        setPujaJugador(6, 100f);
    }//GEN-LAST:event_jButton100J6ActionPerformed

    private void jButton100J5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J5ActionPerformed
        setPujaJugador(5, 100f);
    }//GEN-LAST:event_jButton100J5ActionPerformed

    private void jButton100J4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J4ActionPerformed
        setPujaJugador(4, 100f);
    }//GEN-LAST:event_jButton100J4ActionPerformed

    private void jButton100J3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J3ActionPerformed
        setPujaJugador(3, 100f);
    }//GEN-LAST:event_jButton100J3ActionPerformed

    private void jButton100J2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J2ActionPerformed
        setPujaJugador(2, 100f);
    }//GEN-LAST:event_jButton100J2ActionPerformed

    private void jButton100J1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton100J1ActionPerformed
        setPujaJugador(1, 100f);
    }//GEN-LAST:event_jButton100J1ActionPerformed

    private void jButtonTerminarSubastaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTerminarSubastaActionPerformed

        if (numJugadorGanador != -1)
        {
            Jugador ganador = juego.getJugadores().get(numJugadorGanador-1);
            
            ganador.comprarEnSubasta(casilla, puja);

            juego.getObservador().actualizaJugador(ganador);

        }
        this.setVisible(false);
        dispose();
        
    }//GEN-LAST:event_jButtonTerminarSubastaActionPerformed
    
    
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private javax.swing.JButton jButton100J1;
    private javax.swing.JButton jButton100J2;
    private javax.swing.JButton jButton100J3;
    private javax.swing.JButton jButton100J4;
    private javax.swing.JButton jButton100J5;
    private javax.swing.JButton jButton100J6;
    private javax.swing.JButton jButton10J1;
    private javax.swing.JButton jButton10J2;
    private javax.swing.JButton jButton10J3;
    private javax.swing.JButton jButton10J4;
    private javax.swing.JButton jButton10J5;
    private javax.swing.JButton jButton10J6;
    private javax.swing.JButton jButton1J1;
    private javax.swing.JButton jButton1J2;
    private javax.swing.JButton jButton1J3;
    private javax.swing.JButton jButton1J4;
    private javax.swing.JButton jButton1J5;
    private javax.swing.JButton jButton1J6;
    private javax.swing.JButton jButtonTerminarSubasta;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabelIcono;
    private javax.swing.JLabel jLabelJugador1;
    private javax.swing.JLabel jLabelJugador2;
    private javax.swing.JLabel jLabelJugador3;
    private javax.swing.JLabel jLabelJugador4;
    private javax.swing.JLabel jLabelJugador5;
    private javax.swing.JLabel jLabelJugador6;
    private javax.swing.JLabel jLabelPrecio;
    private javax.swing.JLabel jLabelPuja;
    private javax.swing.JPanel jPanel1;
    // Fin de declaracin de variables//GEN-END:variables
 
    
        
    
}
