/*
 * GuiTablero.java
 *
 * Created on 25 de diciembre de 2007, 16:34
 */

package interfaz;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Vector;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.ScrollPaneLayout;
import javax.swing.border.LineBorder;
import uhupoly.*;

/**
 *
 * @author  Pandre
 */
public class GuiTablero extends JFrame {

    private static EntityManagerFactory emf = Persistence.createEntityManagerFactory("UHUPolyPU");
    
    ObservadorTablero observador;
    Juego juego;
    
    /** Creates new form GuiTablero */
    public GuiTablero(Juego jug) {
        
        juego = null;
        final GuiTablero esteTablero = this;
        
        initComponents();
        
        this.setExtendedState(this.getExtendedState() | JFrame.MAXIMIZED_BOTH);
        
//        canvasTablero.setSize(720,720);
        canvasTablero.setSize(912,912);
        canvasTablero.inicializar();
        jBtnLanzarDados.setVisible(false);
        
        jPanelJugador1.setVisible(false);
        jPanelJugador2.setVisible(false);
        jPanelJugador3.setVisible(false);
        jPanelJugador4.setVisible(false);
        jPanelJugador5.setVisible(false);
        jPanelJugador6.setVisible(false);
        
        /* Se crea el observador */
        observador = new ObservadorTablero() {
            
            public void mostrarLogotipo(boolean aclarado) {
            
                canvasTablero.pintaLogo(aclarado);
                
            }
            
            public void actualizaCasilla(Casilla cas)
            {
                // repinta la casilla
                canvasTablero.pintarCasilla(cas.getIdCasilla());
                
                // si es un Solar, repinta las casas que pudiera haber
                if (cas instanceof Solar)
                {
                    canvasTablero.pintarCasa(((Solar)cas).getNumCasas(), cas.getIdCasilla());
                    
                    // si hay un hotel, lo repinta tambin
                    if (((Solar)cas).getTieneHotel())
                        canvasTablero.pintarHotel(cas.getIdCasilla());
                    
                    if (((Solar)cas).getPropietario() != null)
                        canvasTablero.pintarPropiedad(cas.getIdCasilla(), ((Solar)cas).getPropietario().getNumJugador());
                    else
                        canvasTablero.pintarPropiedad(cas.getIdCasilla(), 0);
                }
                
                if (cas instanceof Estacion)
                {
                    
                    if (((Estacion)cas).getPropietario() != null)
                        canvasTablero.pintarPropiedad(cas.getIdCasilla(), ((Estacion)cas).getPropietario().getNumJugador());
                    
                }
                
                if (cas instanceof ServicioPublico)
                {
                    
                    if (((ServicioPublico)cas).getPropietario() != null)
                        canvasTablero.pintarPropiedad(cas.getIdCasilla(), ((ServicioPublico)cas).getPropietario().getNumJugador());
                    
                }
                
                // repinta los jugadores en el tablero
                for (int i = 0; i < juego.getNumJugadores(); i++)
                    if (!juego.getJugadores().get(i).getArruinado())
                        canvasTablero.pintarJugador(i+1, juego.getJugadores().get(i).getPosicion().getIdCasilla());
                
            }
            
            public void muestraTurnoLanzar(String nombre) {

                jLabelInformacion.setVisible(true);
                jLabelInformacion.setText(" ");
                jLabelTurno.setText("<html><p align=\"center\"><b>Es el turno de <font size=\"22\">" + nombre + "</font></p></html>");
                jBtnLanzarDados.setVisible(true);
                
            }
            
            public void muestraTirada(int dado1, int dado2) {
            
                jLabelInformacion.setVisible(true);
                jLabelInformacion.setText("<html><p align=\"center\">Has sacado un <font size=\"8\">" + dado1 + "</font> y un <font size=\"8\">" + dado2 + "</font>");
                if (dado1 == dado2)
                    jLabelInformacion2.setText("<html><p align=\"center\"><font color=\"#00FF00\">SACASTE DOBLES! Un <font size=\"6\">" + dado1 + "</font> y un <font size=\"6\">" + dado2 + "</font></font>");
            
            }
            
            public void muestraMensaje(String mensaje) {
            
                jLabelInformacion.setVisible(true);
                jLabelInformacion.setText("<html><p align=\"center\">" + mensaje);
            
            }
            
            public void muestraMensajeSecundario(String mensaje){
                
                jLabelInformacion2.setText("<html><p align=\"center\"><font color=\"#00FF00\">" + mensaje + "</font>");
                
            }
            
            public void muestraInformacion(String mensaje) {
            
                jLabelMensaje.setText("<html><p align=\"center\">" + mensaje);
                
            }
            
            public void muestraTerminarTurno() {
            
                jButtonTerminarTurno.setEnabled(true);
            
            }
            
            public void activaOpciones() {
            
                jButtonEdificar.setEnabled(true);
                jButtonVender.setEnabled(true);
                jButtonHipotecas.setEnabled(true);
                
            }
            
            public void inactivaOpciones() {
            
                jButtonEdificar.setEnabled(false);
                jButtonVender.setEnabled(false);
                jButtonHipotecas.setEnabled(false);
            
            }
            
            public void muestraOpcionCompra(Casilla casilla, Jugador jugadorActual, Juego juego) {
            
                // muestra opcion de compra
                GuiCompraPropiedad jdCompraPropiedad = new GuiCompraPropiedad(esteTablero, true, casilla, jugadorActual, juego);
                jdCompraPropiedad.setLocation(esteTablero.getWidth()/2-jdCompraPropiedad.getWidth()/2, 
                    esteTablero.getHeight()/2-jdCompraPropiedad.getHeight()/2);
                jdCompraPropiedad.setVisible(true);
            
            }
            
            public void muestraOpcionSubasta(Casilla casilla, Juego juego) {
            
                GuiSubastaPropiedad jdSubasta = new GuiSubastaPropiedad(esteTablero, true, casilla, juego);
                jdSubasta.setLocation(esteTablero.getWidth()/2-jdSubasta.getWidth()/2, 
                    esteTablero.getHeight()/2-jdSubasta.getHeight()/2);
                jdSubasta.setVisible(true);
            
            }
            
            public void muestraJugadores(Juego juego) {
            
                switch (juego.getJugadores().size()) {
                    case 6: {
                                jPanelJugador6.setVisible(true);
                                jLabelIconoJ6.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ6.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(5).getNombre());
                                jLabelSaldoJ6.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(5).getCapital() + "");
                            }
                    case 5: {
                                jPanelJugador5.setVisible(true);
                                jLabelIconoJ5.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ5.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(4).getNombre());
                                jLabelSaldoJ5.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(4).getCapital() + "");
                            }
                    case 4: {
                                jPanelJugador4.setVisible(true);
                                jLabelIconoJ4.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ4.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(3).getNombre());
                                jLabelSaldoJ4.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(3).getCapital() + "");
                            }
                    case 3: {
                                jPanelJugador3.setVisible(true);
                                jLabelIconoJ3.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ3.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(2).getNombre());
                                jLabelSaldoJ3.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(2).getCapital() + "");
                            }
                    default: {
                                jPanelJugador2.setVisible(true);
                                jLabelIconoJ2.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ2.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(1).getNombre());
                                jLabelSaldoJ2.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(1).getCapital() + "");

                                jPanelJugador1.setVisible(true);
                                jLabelIconoJ1.setIcon(new ImageIcon("res/jugador.png"));
                                jLabelNombreJ1.setText("<html><font size=\"4\"><b>" + juego.getJugadores().get(0).getNombre());
                                jLabelSaldoJ1.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + juego.getJugadores().get(0).getCapital() + "");
                            }
                }

                
            }
            
            public void actualizaJugador(Jugador jugador) {
                
                if (!jugador.getArruinado())
            
                switch (jugador.getNumJugador()) {
                
                    case 1:
                    {
                        jLabelSaldoJ1.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                    case 2:
                    {
                        jLabelSaldoJ2.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                    case 3:
                    {
                        jLabelSaldoJ3.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                    case 4:
                    {
                        jLabelSaldoJ4.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                    case 5:
                    {
                        jLabelSaldoJ5.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                    case 6:
                    {
                        jLabelSaldoJ6.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">" + jugador.getCapital() + "");
                    } break;
                
                }
            
            }
            
            public void muestraSinDinero(Jugador jugadorActual, float cantidad) {
            
                GuiSinDinero jdSinDinero = new GuiSinDinero(esteTablero, true, juego, cantidad);
                jdSinDinero.setLocation(esteTablero.getWidth()/2-jdSinDinero.getWidth()/2, 
                esteTablero.getHeight()/2-jdSinDinero.getHeight()/2);
                jdSinDinero.setVisible(true);
            
            }
            
            public void muestraArruinado(Jugador jugadorActual) {
            
                jLabelInformacion2.setText("<html><p align=\"center\"><font color=\"#00FF00\">" + jugadorActual.getNombre() + ", ests aruinado...<br>Quedas fuera del juego</font>");
                
                switch (jugadorActual.getNumJugador()) {
                
                    case 1: jLabelSaldoJ1.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;
                    case 2: jLabelSaldoJ2.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;
                    case 3: jLabelSaldoJ3.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;
                    case 4: jLabelSaldoJ4.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;
                    case 5: jLabelSaldoJ5.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;
                    case 6: jLabelSaldoJ6.setText("<html><p><font color=\"#CC3300\">- - - ARRUINADO - - -</font></p></html>"); break;

                }
                
                inactivaOpciones();
            
            }
            
            public void muestraFinDelJuego(Juego juego, Jugador jugador) {
            
                GuiFinDelJuego jdFinJuego = new GuiFinDelJuego(esteTablero, true, juego, jugador);
                jdFinJuego.setLocation(esteTablero.getWidth()/2-jdFinJuego.getWidth()/2, 
                    esteTablero.getHeight()/2-jdFinJuego.getHeight()/2);
                jdFinJuego.setVisible(true);
            
            }
            
            
            public void muestraEncarcelado(Jugador jugador, boolean encarcelado) {
            
                switch (jugador.getNumJugador()) {
                
                    case 1:
                    {
                        if (encarcelado)
                            jLabelIconoJ1.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ1.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                    case 2:
                    {
                        if (encarcelado)
                            jLabelIconoJ2.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ2.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                    case 3:
                    {
                        if (encarcelado)
                            jLabelIconoJ3.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ3.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                    case 4:
                    {
                        if (encarcelado)
                            jLabelIconoJ4.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ4.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                    case 5:
                    {
                        if (encarcelado)
                            jLabelIconoJ5.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ5.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                    case 6:
                    {
                        if (encarcelado)
                            jLabelIconoJ6.setIcon(new ImageIcon("res/jugadorCarcel.png"));
                        else
                            jLabelIconoJ6.setIcon(new ImageIcon("res/jugador.png"));
                    } break;
                
                }
                
            
            }
            
        };
        
        //juego.setObservador(observador);
        
    }
    
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Generado  ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPaneTablero = new javax.swing.JScrollPane();
        canvasTablero = new interfaz.UHUPolyCanvas();
        jBtnLanzarDados = new javax.swing.JButton();
        jLabelInformacion = new javax.swing.JLabel();
        jLabelMensaje = new javax.swing.JLabel();
        jLabelInformacion2 = new javax.swing.JLabel();
        jLabelTurno = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jButtonVender = new javax.swing.JButton();
        jButtonEdificar = new javax.swing.JButton();
        jButtonHipotecas = new javax.swing.JButton();
        jButtonTerminarTurno = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        jPanelJugador1 = new javax.swing.JPanel();
        jLabelIconoJ1 = new javax.swing.JLabel();
        jLabelNombreJ1 = new javax.swing.JLabel();
        jLabelSaldoJ1 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jPanelJugador2 = new javax.swing.JPanel();
        jLabelIconoJ2 = new javax.swing.JLabel();
        jLabelNombreJ2 = new javax.swing.JLabel();
        jLabelSaldoJ2 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jPanelJugador3 = new javax.swing.JPanel();
        jLabelIconoJ3 = new javax.swing.JLabel();
        jLabelNombreJ3 = new javax.swing.JLabel();
        jLabelSaldoJ3 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jPanelJugador4 = new javax.swing.JPanel();
        jLabelIconoJ4 = new javax.swing.JLabel();
        jLabelNombreJ4 = new javax.swing.JLabel();
        jLabelSaldoJ4 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jPanelJugador5 = new javax.swing.JPanel();
        jLabelIconoJ5 = new javax.swing.JLabel();
        jLabelNombreJ5 = new javax.swing.JLabel();
        jLabelSaldoJ5 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jPanelJugador6 = new javax.swing.JPanel();
        jLabelIconoJ6 = new javax.swing.JLabel();
        jLabelNombreJ6 = new javax.swing.JLabel();
        jLabelSaldoJ6 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItemNuevaPartida = new javax.swing.JMenuItem();
        jMenuItemCargarPartida = new javax.swing.JMenuItem();
        jMenuItemGuardarPartida = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItemAcerca = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("UHUpoly - Universidad de Huelva");
        setName("jfPrincipal");
        canvasTablero.setPreferredSize(new java.awt.Dimension(912, 912));
        jBtnLanzarDados.setFont(new java.awt.Font("Tahoma", 1, 18));
        jBtnLanzarDados.setIcon(new javax.swing.ImageIcon("res\\btnTirarDados.gif"));
        jBtnLanzarDados.setText("     LANZAR DADOS     ");
        jBtnLanzarDados.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBtnLanzarDadosActionPerformed(evt);
            }
        });

        jLabelInformacion.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelInformacion.setForeground(new java.awt.Color(0, 102, 255));
        jLabelInformacion.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelInformacion.setText(" ");

        jLabelMensaje.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelMensaje.setForeground(new java.awt.Color(0, 102, 255));
        jLabelMensaje.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelMensaje.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabelMensaje.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jLabelInformacion2.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelInformacion2.setForeground(new java.awt.Color(0, 102, 255));
        jLabelInformacion2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelInformacion2.setText(" ");

        jLabelTurno.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabelTurno.setForeground(new java.awt.Color(0, 204, 204));
        jLabelTurno.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelTurno.setText(" ");

        javax.swing.GroupLayout canvasTableroLayout = new javax.swing.GroupLayout(canvasTablero);
        canvasTablero.setLayout(canvasTableroLayout);
        canvasTableroLayout.setHorizontalGroup(
            canvasTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, canvasTableroLayout.createSequentialGroup()
                .addContainerGap(186, Short.MAX_VALUE)
                .addGroup(canvasTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, canvasTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jLabelMensaje, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabelInformacion2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabelInformacion, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabelTurno, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 552, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, canvasTableroLayout.createSequentialGroup()
                        .addComponent(jBtnLanzarDados, javax.swing.GroupLayout.PREFERRED_SIZE, 318, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(122, 122, 122)))
                .addGap(174, 174, 174))
        );
        canvasTableroLayout.setVerticalGroup(
            canvasTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(canvasTableroLayout.createSequentialGroup()
                .addGap(242, 242, 242)
                .addComponent(jLabelTurno, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelInformacion, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelInformacion2)
                .addGap(27, 27, 27)
                .addComponent(jBtnLanzarDados, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(16, 16, 16)
                .addComponent(jLabelMensaje, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(252, Short.MAX_VALUE))
        );
        jScrollPaneTablero.setViewportView(canvasTablero);

        jPanel1.setAutoscrolls(true);
        jButtonVender.setIcon(new javax.swing.ImageIcon("res\\btnComprarPropiedades.gif"));
        jButtonVender.setText("Vender propiedades");
        jButtonVender.setEnabled(false);
        jButtonVender.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVenderActionPerformed(evt);
            }
        });

        jButtonEdificar.setIcon(new javax.swing.ImageIcon("res\\btnEdificar.gif"));
        jButtonEdificar.setText("Edificar");
        jButtonEdificar.setEnabled(false);
        jButtonEdificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonEdificarActionPerformed(evt);
            }
        });

        jButtonHipotecas.setIcon(new javax.swing.ImageIcon("res\\btnHipotecas.gif"));
        jButtonHipotecas.setText("Hipotecas");
        jButtonHipotecas.setEnabled(false);
        jButtonHipotecas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonHipotecasActionPerformed(evt);
            }
        });

        jButtonTerminarTurno.setFont(new java.awt.Font("Tahoma", 3, 11));
        jButtonTerminarTurno.setText("Terminar turno");
        jButtonTerminarTurno.setEnabled(false);
        jButtonTerminarTurno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTerminarTurnoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jButtonEdificar, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonVender, javax.swing.GroupLayout.PREFERRED_SIZE, 210, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonHipotecas, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 548, Short.MAX_VALUE)
                .addComponent(jButtonTerminarTurno, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButtonHipotecas, javax.swing.GroupLayout.DEFAULT_SIZE, 45, Short.MAX_VALUE)
            .addComponent(jButtonTerminarTurno, javax.swing.GroupLayout.DEFAULT_SIZE, 45, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jButtonEdificar, javax.swing.GroupLayout.DEFAULT_SIZE, 45, Short.MAX_VALUE)
                .addComponent(jButtonVender, javax.swing.GroupLayout.DEFAULT_SIZE, 45, Short.MAX_VALUE))
        );

        jPanel3.setBackground(new java.awt.Color(204, 204, 255));
        jPanel3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 51, 51), 2, true));
        jLabel13.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel13.setText("Jugadores");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 289, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel13)
                .addContainerGap())
        );

        jPanelJugador1.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 102, 255), 2, true));
        jLabelIconoJ1.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ1.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ1.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador1Layout = new javax.swing.GroupLayout(jPanelJugador1);
        jPanelJugador1.setLayout(jPanelJugador1Layout);
        jPanelJugador1Layout.setHorizontalGroup(
            jPanelJugador1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelSaldoJ1, javax.swing.GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE)
                    .addComponent(jLabelNombreJ1, javax.swing.GroupLayout.DEFAULT_SIZE, 189, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador1Layout.setVerticalGroup(
            jPanelJugador1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelJugador1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelJugador1Layout.createSequentialGroup()
                        .addComponent(jLabelNombreJ1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabelSaldoJ1))
                    .addComponent(jLabelIconoJ1, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jPanelJugador2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 255, 0), 2, true));
        jLabelIconoJ2.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ2.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ2.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador2Layout = new javax.swing.GroupLayout(jPanelJugador2);
        jPanelJugador2.setLayout(jPanelJugador2Layout);
        jPanelJugador2Layout.setHorizontalGroup(
            jPanelJugador2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNombreJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelSaldoJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador2Layout.setVerticalGroup(
            jPanelJugador2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelJugador2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanelJugador2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelIconoJ2, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelJugador2Layout.createSequentialGroup()
                        .addComponent(jLabelNombreJ2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabelSaldoJ2)))
                .addContainerGap())
        );

        jPanelJugador3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(255, 0, 0), 2, true));
        jLabelIconoJ3.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ3.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ3.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador3Layout = new javax.swing.GroupLayout(jPanelJugador3);
        jPanelJugador3.setLayout(jPanelJugador3Layout);
        jPanelJugador3Layout.setHorizontalGroup(
            jPanelJugador3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ3, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNombreJ3, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelSaldoJ3, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador3Layout.setVerticalGroup(
            jPanelJugador3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelJugador3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelJugador3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanelJugador3Layout.createSequentialGroup()
                            .addComponent(jLabelNombreJ3)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelSaldoJ3))
                        .addComponent(jLabelIconoJ3, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanelJugador4.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(255, 255, 0), 2, true));
        jLabelIconoJ4.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ4.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ4.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador4Layout = new javax.swing.GroupLayout(jPanelJugador4);
        jPanelJugador4.setLayout(jPanelJugador4Layout);
        jPanelJugador4Layout.setHorizontalGroup(
            jPanelJugador4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ4, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNombreJ4, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelSaldoJ4, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador4Layout.setVerticalGroup(
            jPanelJugador4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelJugador4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelJugador4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanelJugador4Layout.createSequentialGroup()
                            .addComponent(jLabelNombreJ4)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelSaldoJ4))
                        .addComponent(jLabelIconoJ4, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanelJugador5.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(204, 0, 204), 2, true));
        jLabelIconoJ5.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ5.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ5.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador5Layout = new javax.swing.GroupLayout(jPanelJugador5);
        jPanelJugador5.setLayout(jPanelJugador5Layout);
        jPanelJugador5Layout.setHorizontalGroup(
            jPanelJugador5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ5, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNombreJ5, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelSaldoJ5, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador5Layout.setVerticalGroup(
            jPanelJugador5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelJugador5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelJugador5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanelJugador5Layout.createSequentialGroup()
                            .addComponent(jLabelNombreJ5)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelSaldoJ5))
                        .addComponent(jLabelIconoJ5, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(15, Short.MAX_VALUE))
        );

        jPanelJugador6.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(255, 102, 0), 2, true));
        jLabelIconoJ6.setIcon(new javax.swing.ImageIcon("res\\jugador.png"));

        jLabelNombreJ6.setText("<html><font size=\"4\"><b>Pandre");

        jLabelSaldoJ6.setText("<html><b><font size=\"2\">Saldo disponible:</font> <font color=\"#008080\" size=\"3\">1772,4\u20ac");

        javax.swing.GroupLayout jPanelJugador6Layout = new javax.swing.GroupLayout(jPanelJugador6);
        jPanelJugador6.setLayout(jPanelJugador6Layout);
        jPanelJugador6Layout.setHorizontalGroup(
            jPanelJugador6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelIconoJ6, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelJugador6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNombreJ6, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelSaldoJ6, javax.swing.GroupLayout.PREFERRED_SIZE, 185, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanelJugador6Layout.setVerticalGroup(
            jPanelJugador6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelJugador6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelJugador6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelJugador6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(jPanelJugador6Layout.createSequentialGroup()
                            .addComponent(jLabelNombreJ6)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabelSaldoJ6))
                        .addComponent(jLabelIconoJ6, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jPanelJugador1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanelJugador2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanelJugador3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanelJugador4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanelJugador5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanelJugador6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelJugador6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(245, Short.MAX_VALUE))
        );

        jMenu1.setText("Partida");
        jMenuItemNuevaPartida.setText("Nueva partida");
        jMenuItemNuevaPartida.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemNuevaPartidaActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItemNuevaPartida);

        jMenuItemCargarPartida.setText("Cargar partida");
        jMenuItemCargarPartida.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemCargarPartidaActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItemCargarPartida);

        jMenuItemGuardarPartida.setText("Guardar partida");
        jMenuItemGuardarPartida.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemGuardarPartidaActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItemGuardarPartida);

        jMenu1.add(jSeparator1);

        jMenuItem3.setText("Salir del juego");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItem3);

        jMenuBar1.add(jMenu1);

        jMenu3.setText("Ayuda");
        jMenuItemAcerca.setText("Acerca de...");
        jMenuItemAcerca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAcercaActionPerformed(evt);
            }
        });

        jMenu3.add(jMenuItemAcerca);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jScrollPaneTablero, javax.swing.GroupLayout.DEFAULT_SIZE, 931, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPaneTablero, javax.swing.GroupLayout.DEFAULT_SIZE, 714, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    private void jMenuItemCargarPartidaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemCargarPartidaActionPerformed

        
        GuiCargarPartida jdCargar = new GuiCargarPartida(this, true, emf);
        jdCargar.setLocation(this.getWidth()/2-jdCargar.getWidth()/2, 
            this.getHeight()/2-jdCargar.getHeight()/2);
        jdCargar.setVisible(true);
        
    }//GEN-LAST:event_jMenuItemCargarPartidaActionPerformed

    
    private void jMenuItemGuardarPartidaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemGuardarPartidaActionPerformed

        if (juego == null)
        {
        
            JOptionPane.showMessageDialog(null, "No hay partidas que guardar. Debes crear o cargar primero una partida.",
                    "No hay partidas que guardar", JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        juego.setFechaGuardado(new GregorianCalendar());
        
        if (jButtonTerminarTurno.isEnabled()) jButtonTerminarTurnoActionPerformed(null);
        
        agregarBD(juego);
        
        JOptionPane.showMessageDialog(null, "La partida se ha guardado!",
                    "Partida guardada", JOptionPane.INFORMATION_MESSAGE);
                
        
    }//GEN-LAST:event_jMenuItemGuardarPartidaActionPerformed

    private void jMenuItemAcercaActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jMenuItemAcercaActionPerformed

        GuiAcercaDe jdAcerca= new GuiAcercaDe(this, true);
        jdAcerca.setLocation(this.getWidth()/2-jdAcerca.getWidth()/2, 
            this.getHeight()/2-jdAcerca.getHeight()/2);
        jdAcerca.setVisible(true);
        
    }//GEN-LAST:event_jMenuItemAcercaActionPerformed

    private void jButtonVenderActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jButtonVenderActionPerformed

        GuiVender jdVender = new GuiVender(this, true, juego);
        jdVender.setLocation(this.getWidth()/2-jdVender.getWidth()/2, 
            this.getHeight()/2-jdVender.getHeight()/2);
        jdVender.setVisible(true);
        
    }//GEN-LAST:event_jButtonVenderActionPerformed

    private void jButtonHipotecasActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jButtonHipotecasActionPerformed

        GuiHipotecas jdHipotecas = new GuiHipotecas(this, true, juego);
        jdHipotecas.setLocation(this.getWidth()/2-jdHipotecas.getWidth()/2, 
            this.getHeight()/2-jdHipotecas.getHeight()/2);
        jdHipotecas.setVisible(true);
        
    }//GEN-LAST:event_jButtonHipotecasActionPerformed

    private void jButtonEdificarActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jButtonEdificarActionPerformed

        GuiEdificar jdEdificar = new GuiEdificar(this, true, juego);
        jdEdificar.setLocation(this.getWidth()/2-jdEdificar.getWidth()/2, 
            this.getHeight()/2-jdEdificar.getHeight()/2);
        jdEdificar.setVisible(true);
        
    }//GEN-LAST:event_jButtonEdificarActionPerformed

    private void jMenuItem3ActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed

        System.exit(0);
        
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jMenuItemNuevaPartidaActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jMenuItemNuevaPartidaActionPerformed

        if (juego != null)
        {
            if (JOptionPane.showConfirmDialog(null, "Deseas guardar la partida actual antes de crear la nueva?",
                        "Guardar partida?", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION)
            {
                jMenuItemGuardarPartidaActionPerformed(null);
            }
        }
        
        jLabelInformacion.setText(" ");
        jLabelInformacion2.setText(" ");
        jLabelMensaje.setText("");
        jLabelTurno.setText("");
        jBtnLanzarDados.setVisible(false);
        
        
        juego = new Juego();
        juego.setObservador(observador);

        jPanelJugador1.setVisible(false);
        jPanelJugador2.setVisible(false);
        jPanelJugador3.setVisible(false);
        jPanelJugador4.setVisible(false);
        jPanelJugador5.setVisible(false);
        jPanelJugador6.setVisible(false);
        
        canvasTablero.inicializar();
        
        // mostramos la ventana de iniciar partida y crear jugadores
        GuiNuevaPartida jdNuevaPartida = new GuiNuevaPartida(this, true, juego);
        jdNuevaPartida.setLocation(this.getWidth()/2-jdNuevaPartida.getWidth()/2, 
            this.getHeight()/2-jdNuevaPartida.getHeight()/2);
        jdNuevaPartida.setVisible(true);
        jLabelInformacion.setVisible(true);
        jLabelInformacion2.setVisible(true);
//        jMenuItemNuevaPartida.setEnabled(false);
        
    }//GEN-LAST:event_jMenuItemNuevaPartidaActionPerformed

    private void jButtonTerminarTurnoActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jButtonTerminarTurnoActionPerformed

        //jLabelMensaje.setText("<html><p align=\"center\"><b>Quedas libre de la crcel por sacar dobles!!!</b><br><br>Vuelves a tirar otra vez</p></html>");
        jLabelInformacion2.setText(" ");
        jLabelMensaje.setText(" ");
        jButtonTerminarTurno.setEnabled(false);
        jButtonVender.setEnabled(false);
        jButtonEdificar.setEnabled(false);
        jButtonHipotecas.setEnabled(false);
        juego.cambiarTurno();
        
    }//GEN-LAST:event_jButtonTerminarTurnoActionPerformed

    private void jBtnLanzarDadosActionPerformed(ActionEvent evt) {//GEN-FIRST:event_jBtnLanzarDadosActionPerformed
                
        jLabelMensaje.setText(" ");
        
        jBtnLanzarDados.setVisible(false);
        jLabelInformacion2.setText(" ");
        juego.jugar();
        
        
    }//GEN-LAST:event_jBtnLanzarDadosActionPerformed
    
    public void setJuegoCargado(Juego juego) {
    
        this.juego = juego;
        
        juego.setObservador(observador);
        
        jPanelJugador3.setVisible(false);
        jPanelJugador4.setVisible(false);
        jPanelJugador5.setVisible(false);
        jPanelJugador6.setVisible(false);
        
        jLabelInformacion.setText("");
        jLabelMensaje.setText("");
        jLabelInformacion2.setText("");
        
        juego.cargadoDesdeBBDD();
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                Juego juego = new Juego();
                
                // mostramos la ventana principal del juego
                GuiTablero jfTablero = new GuiTablero(null);
                jfTablero.setVisible(true);
                
            }
        });
    }

    
    // Declaracin de varibales -no modificar//GEN-BEGIN:variables
    private interfaz.UHUPolyCanvas canvasTablero;
    private javax.swing.JButton jBtnLanzarDados;
    private javax.swing.JButton jButtonEdificar;
    private javax.swing.JButton jButtonHipotecas;
    private javax.swing.JButton jButtonTerminarTurno;
    private javax.swing.JButton jButtonVender;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelIconoJ1;
    private javax.swing.JLabel jLabelIconoJ2;
    private javax.swing.JLabel jLabelIconoJ3;
    private javax.swing.JLabel jLabelIconoJ4;
    private javax.swing.JLabel jLabelIconoJ5;
    private javax.swing.JLabel jLabelIconoJ6;
    private javax.swing.JLabel jLabelInformacion;
    private javax.swing.JLabel jLabelInformacion2;
    private javax.swing.JLabel jLabelMensaje;
    private javax.swing.JLabel jLabelNombreJ1;
    private javax.swing.JLabel jLabelNombreJ2;
    private javax.swing.JLabel jLabelNombreJ3;
    private javax.swing.JLabel jLabelNombreJ4;
    private javax.swing.JLabel jLabelNombreJ5;
    private javax.swing.JLabel jLabelNombreJ6;
    private javax.swing.JLabel jLabelSaldoJ1;
    private javax.swing.JLabel jLabelSaldoJ2;
    private javax.swing.JLabel jLabelSaldoJ3;
    private javax.swing.JLabel jLabelSaldoJ4;
    private javax.swing.JLabel jLabelSaldoJ5;
    private javax.swing.JLabel jLabelSaldoJ6;
    private javax.swing.JLabel jLabelTurno;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItemAcerca;
    private javax.swing.JMenuItem jMenuItemCargarPartida;
    private javax.swing.JMenuItem jMenuItemGuardarPartida;
    private javax.swing.JMenuItem jMenuItemNuevaPartida;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanelJugador1;
    private javax.swing.JPanel jPanelJugador2;
    private javax.swing.JPanel jPanelJugador3;
    private javax.swing.JPanel jPanelJugador4;
    private javax.swing.JPanel jPanelJugador5;
    private javax.swing.JPanel jPanelJugador6;
    private javax.swing.JScrollPane jScrollPaneTablero;
    private javax.swing.JSeparator jSeparator1;
    // Fin de declaracin de variables//GEN-END:variables

    public static void agregarBD(Object object) {
        javax.persistence.EntityManager em = emf.createEntityManager();
        
        em.getTransaction().begin();
        try {

            em.merge(object);

            em.getTransaction().commit();

        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
    
    
}
