package uhupoly;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Esquina extends Casilla implements Serializable {
    
    private int numEsquina;

    public Esquina(int num) {
        numEsquina = num;
    }
    
    public Esquina() {
        numEsquina = 0;
    }

    public int getNumEsquina() {
        return numEsquina;
    }

    public void setNumEsquina(int val) {
        this.numEsquina = val;
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        boolean res = true;
        
        switch (numEsquina) {
        
            case 1: { // casilla de salida
                jugadorActual.setPosicion(this);
            } break;
            case 2: { // crcel
                jugadorActual.setDeVisita(true);
                jugadorActual.setPosicion(this);
            } break;
            case 3: { // parking gratuito
                jugadorActual.setPosicion(this);
            } break;
            case 4: { // ve a la crcel
                //directo a la carcel
                jugadorActual.setTurnosEnCarcel(3);
                jugadorActual.setDeVisita(false);
                jugadorActual.setPosicion(juego.getTablero().getCasillas().get(10));
                //muestra que son 3 dobles y va a la carcel
                juego.getObservador().muestraMensaje("<b>Vas directo a la crcel!!!</b>");
                //activa TERMINAR_____________
                juego.getObservador().inactivaOpciones();
                juego.getObservador().muestraTerminarTurno();
                juego.getObservador().muestraEncarcelado(jugadorActual, true);
                
                res = false;
            }
        
        }
    
        return res;
    }
}
