package uhupoly;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Penalizacion extends Casilla implements Serializable {

    private float cantidad;

    public Penalizacion(float cant) {
        cantidad = cant;
    }
    
    public Penalizacion() {
        cantidad = 238f;
    }

    public float getCantidad() {
        return cantidad;
    }

    public void setCantidad(float val) {
        this.cantidad = val;
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        Casilla casillaAnterior = jugadorActual.getPosicion();
        
        jugadorActual.setPosicion(this);
        juego.getObservador().actualizaCasilla(this);
        juego.getObservador().actualizaCasilla(casillaAnterior);
        
        // comprobar si tiene capital suficiente en dinero. De ser as,
        // mostrar aqu la obligacin de tener que hipotecar.
        
        while (!jugadorActual.tieneEfectivo(this.getCantidad()))
        {
            if (jugadorActual.estaArruinado(this.getCantidad()))
            {
                jugadorActual.entregarTodoA(null, juego);
                juego.getObservador().muestraArruinado(jugadorActual);
                juego.getObservador().muestraTerminarTurno();
                return false;
            }
            else juego.getObservador().muestraSinDinero(jugadorActual, this.getCantidad());
        }
                
        // restar al capital
        jugadorActual.setCapital(jugadorActual.getCapital() - this.getCantidad());
            
        // notifica operacin
        juego.getObservador().muestraInformacion("<html>Pagas un impuesto por valor de <b>" + this.getCantidad() + "</b>");
        
        return true;
    
    }
}
