package uhupoly;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Propiedad extends Casilla implements Serializable {
    private float precio;

    private float valorHipoteca;

    @OneToOne
    private Jugador propietario;
    
    private boolean hipotecada;

    public Propiedad() {
        propietario = null;
        hipotecada = false;
    }

    public float getPrecio() {
        return precio;
    }

    public void setPrecio(float val) {
        this.precio = val;
    }

    public Jugador getPropietario() {
        return propietario;
    }

    public void setPropietario(Jugador val) {
        this.propietario = val;
    }

    public float getValorHipoteca() {
        return valorHipoteca;
    }

    public void setValorHipoteca(float val) {
        this.valorHipoteca = val;
    }
    
    public boolean getHipotecada() {
        return hipotecada;
    }

    public void setHipotecada(boolean val) {
        this.hipotecada = val;
    }
    
    public void hipotecar() {
        
        hipotecada = true;
        propietario.setCapital(propietario.getCapital() + valorHipoteca);
        
    }
    
    public void deshipotecar() {
        
        hipotecada = false;
        propietario.setCapital(propietario.getCapital() - (valorHipoteca + valorHipoteca * 0.1f ));
        
    }
}
