package uhupoly;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class ServicioPublico extends Propiedad implements Serializable {
    public ServicioPublico() {
        
        setPrecio(178.5f);
        setValorHipoteca(90.15f);
        
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        Casilla casillaAnterior = jugadorActual.getPosicion();
        
        jugadorActual.setPosicion(this);
        juego.getObservador().actualizaCasilla(this);
        juego.getObservador().actualizaCasilla(casillaAnterior);
        
        if (this.getPropietario() == null)
        {
            
            // actualiza las casillas en el tablero
            juego.getObservador().actualizaCasilla(casillaAnterior);
            juego.getObservador().actualizaCasilla(this);
            
            // muestra opcion de compra
            juego.getObservador().muestraOpcionCompra(this, jugadorActual, juego);
            
        } else
        {
            
            // resta alquiler y suma al propietario
            Jugador propietario = this.getPropietario();
            float alquiler = 0;
            int dados = juego.getValorDado1() + juego.getValorDado2();
            int numServicios = 0;
            
            if (propietario != jugadorActual)
            {

                for (int i = 0; i < propietario.getPropiedades().size(); i++)
                    if (propietario.getPropiedades().get(i) instanceof ServicioPublico)
                        numServicios++;
            
                if (numServicios == 1)
                {
            
                    alquiler = dados * 4.8f;
            
                }
                if (numServicios == 2)
                {
            
                    alquiler = dados * 12f;
            
                }        
           
                
                // comprobar si tiene capital suficiente en dinero. De ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
                while (!jugadorActual.tieneEfectivo(alquiler))
                {
                    if (jugadorActual.estaArruinado(alquiler))
                    {
                        jugadorActual.entregarTodoA(propietario, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return false;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, alquiler);
                }
            
                // restar al capital
                jugadorActual.setCapital(jugadorActual.getCapital() - alquiler);
            
                // notifica operacin 
                juego.getObservador().muestraInformacion("<html>Pagas un alquiler de <b>" + alquiler + "</b> a " + propietario.getNombre());
            
            }
            
        }
        
        return true;
    }
    
}
