package uhupoly;

import interfaz.GuiCompraPropiedad;
import java.lang.Float;
import java.util.ArrayList;

import java.io.Serializable;
import java.util.List;
import java.util.Vector;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Solar extends Propiedad implements Serializable {

    private float precioCasa;

    private int numCasas;

    private boolean tieneHotel;

    private float precioHotel;
    
    private float preAlquiler0Casas;
    private float preAlquiler1Casas;
    private float preAlquiler2Casas;
    private float preAlquiler3Casas;
    private float preAlquiler4Casas;
    private float preAlquilerHotel;
    
    @OneToMany(cascade=CascadeType.ALL)
    
    private List<Solar> asociados;

    public Solar(float precio, float valHipoteca, float preCasa, float preHotel, float alq,
            float alq1casa, float alq2casa, float alq3casa, float alq4casa, float alqHotel) {
        
        super();
        
        asociados = new ArrayList<Solar>();
        setPrecio(precio);
        setValorHipoteca(valHipoteca);
        precioCasa = preCasa;
        precioHotel = preHotel;
        
        preAlquiler0Casas = alq;
        preAlquiler1Casas = alq1casa;
        preAlquiler2Casas = alq2casa;
        preAlquiler3Casas = alq3casa;
        preAlquiler4Casas = alq4casa;
        preAlquilerHotel = alqHotel;
        
        numCasas = 0;
        tieneHotel = false;
        
    }
    
    public Solar() {
        super();
        
        asociados = new ArrayList<Solar>();
        setPrecio(0);
        setValorHipoteca(0);
        precioCasa = 0;
        precioHotel = 0;
        preAlquiler0Casas = 0;
        preAlquiler1Casas = 0;
        preAlquiler2Casas = 0;
        preAlquiler3Casas = 0;
        preAlquiler4Casas = 0;
        preAlquilerHotel = 0;
        
        numCasas = 0;
        tieneHotel = false;
    }

    public float getPrecioCasa() {
        return precioCasa;
    }

    public void setPrecioCasa(float val) {
        this.precioCasa = val;
    }

    public int getNumCasas() {
        return numCasas;
    }

    public void setNumCasas(int val) {
        this.numCasas = val;
    }

    
    public List<Solar> getAsociados() {
        return asociados;
    }

    public void setAsociados(ArrayList<Solar> val) {
        this.asociados = val;
    }

    public boolean getTieneHotel() {
        return tieneHotel;
    }

    public void setTieneHotel(boolean val) {
        this.tieneHotel = val;
    }

    public float getPrecioHotel() {
        return precioHotel;
    }

    public void setPrecioHotel(float val) {
        this.precioHotel = val;
    }

    public float getAlquileres(int idx) {
        float res = 0;
        switch (idx) {
            case 0: res = preAlquiler0Casas; break;
            case 1: res = preAlquiler1Casas; break;
            case 2: res = preAlquiler2Casas; break;
            case 3: res = preAlquiler3Casas; break;
            case 4: res = preAlquiler4Casas; break;
            case 5: res = preAlquilerHotel; break;
        }
        return res;
    }
    
    public boolean accion(Jugador jugadorActual, Juego juego) {
    
        Casilla casillaAnterior = jugadorActual.getPosicion();
        
        jugadorActual.setPosicion(this);
        juego.getObservador().actualizaCasilla(this);
        juego.getObservador().actualizaCasilla(casillaAnterior);
        
        if (this.getPropietario() == null)
        {
            // actualiza las casillas en el tablero
            juego.getObservador().actualizaCasilla(casillaAnterior);
            juego.getObservador().actualizaCasilla(this);
            
            // muestra opcion de compra
            juego.getObservador().muestraOpcionCompra(this, jugadorActual, juego);
                
        } else
        {
            
            // resta alquiler y suma al propietario
            Jugador propietario = this.getPropietario();
            float alquiler = 0;
            
            // Realizar alquiler slo si el jugador no es el dueo
            if (jugadorActual != propietario)
            {
                
                if (this.getTieneHotel())
                    alquiler = this.getAlquileres(5);
                else
                    alquiler = this.getAlquileres(this.getNumCasas());
                
                
                // comprobar si tiene suficiente en dinero. De no ser as,
                // mostrar aqu la obligacin de tener que hipotecar.
                while (!jugadorActual.tieneEfectivo(alquiler))
                {

                    if (jugadorActual.estaArruinado(alquiler))
                    {
                        jugadorActual.entregarTodoA(propietario, juego);
                        juego.getObservador().muestraArruinado(jugadorActual);
                        juego.getObservador().muestraTerminarTurno();
                        return false;
                    }
                    else juego.getObservador().muestraSinDinero(jugadorActual, alquiler);
                }
               
                // hacer traspaso de capital
                jugadorActual.setCapital(jugadorActual.getCapital() - alquiler);
                propietario.setCapital(propietario.getCapital() + alquiler);
               
                juego.getObservador().actualizaJugador(propietario);

                // notifica operacin
            juego.getObservador().muestraInformacion("<html>Pagas un alquiler de <b>" + alquiler + "</b> a " + propietario.getNombre());
            }
                
        }
        
        return true;
    }
    
    public void construyeCasa() {
    
        if (getPropietario() == null) return;
        if ((numCasas < 4) && getPropietario().tieneEfectivo(precioCasa))
        {
            numCasas++;
            getPropietario().setCapital(getPropietario().getCapital() - precioCasa);
        }
        else
            construyeHotel();
        
    }
    
    public void construyeHotel() {
    
        if (getPropietario() == null) return;
        if (getPropietario().tieneEfectivo(precioHotel))
        {
            tieneHotel = true;
            getPropietario().setCapital(getPropietario().getCapital() - precioHotel);
        }
        
    }

}
