package uhupoly;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;

@Entity
public class Tablero implements Serializable {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="IDTablero")
    private Long id;

    @OneToMany(cascade=CascadeType.ALL)
    private List<Casilla> casillas;
    
    /**
     * ######### PERSISTENCIA #####################
     */
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tablero)) {
            return false;
        }
        Tablero other = (Tablero)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "Tablero";
        return res;
    }
    
     /**
     * ######### FIN PERSISTENCIA #####################
     */

    public Tablero() {
        // creamos las 40 casillas
        casillas = new ArrayList<Casilla>();
        //( precio, valHipoteca, preCasa, preHotel, alq, alq1casa, alq2casa, alq3casa, alq4casa, alqHotel) 
        /* 1 */casillas.add(new Esquina(1));
        
        /* 2 */casillas.add(new Solar(71.4f, 36.1f, 60.1f, 60.1f, 2.4f, 24.0f, 72.1f, 216.4f, 384.6f, 540.9f));
        /* 3 */casillas.add(new Comunidad());
        /* 4 */casillas.add(new Solar(71.4f, 36.1f, 60.1f, 60.1f, 2.4f, 24.0f, 72.1f, 216.4f, 384.6f, 540.9f));
        /* 5 */casillas.add(new Penalizacion(238f));
        /* 6 */casillas.add(new Estacion());
        /* 7 */casillas.add(new Solar(119f, 60.1f, 60.1f, 60.1f, 7.2f, 36.1f, 108.2f, 300.5f, 480.8f, 661.1f));
        /* 8 */casillas.add(new Suerte());
        /* 9 */casillas.add(new Solar(119f, 60.1f, 60.1f, 60.1f, 7.2f, 36.1f, 108.2f, 300.5f, 480.8f, 661.1f));
        /* 10 */casillas.add(new Solar(142.8f, 72.1f, 60.1f, 60.1f, 9.6f, 48.1f, 120.2f, 360.6f, 540.9f, 721.2f));
        
        /* 11 */casillas.add(new Esquina(2));
        
        /* 12 */casillas.add(new Solar(166.6f, 84.1f, 120.2f, 120.2f, 12f, 60.1f, 180.3f, 540.9f, 721.2f, 901.5f));
        /* 13 */casillas.add(new ServicioPublico());
        /* 14 */casillas.add(new Solar(166.6f, 84.1f, 120.2f, 120.2f, 12f, 60.1f, 180.3f, 540.9f, 721.2f, 901.5f));
        /* 15 */casillas.add(new Solar(190.4f, 96.2f, 120.2f, 120.2f, 14.4f, 72.1f, 216.4f, 601f, 841.4f, 1081.8f));
        /* 16 */casillas.add(new Estacion());
        /* 17 */casillas.add(new Solar(214.2f, 108.2f, 120.2f, 120.2f, 16.8f, 84.1f, 240.4f, 661.1f, 901.5f, 1141.9f));
        /* 18 */casillas.add(new Comunidad());
        /* 19 */casillas.add(new Solar(214.2f, 108.2f, 120.2f, 120.2f, 16.8f, 84.1f, 240.4f, 661.1f, 901.5f, 1141.9f));
        /* 20 */casillas.add(new Solar(238f, 120.2f, 120.2f, 120.2f, 19.2f, 96.2f, 264.4f, 721.2f, 961.6f, 1202f));
        
        /* 21 */casillas.add(new Esquina(3));
        
        /* 22 */casillas.add(new Solar(261.9f, 132.2f, 180.3f, 180.3f, 21.6f, 108.2f, 300.5f, 841.4f, 1051.8f, 1262.1f));
        /* 23 */casillas.add(new Suerte());
        /* 24 */casillas.add(new Solar(261.9f, 132.2f, 180.3f, 180.3f, 21.6f, 108.2f, 300.5f, 841.4f, 1051.8f, 1262.1f));
        /* 25 */casillas.add(new Solar(261.9f, 132.2f, 180.3f, 180.3f, 21.6f, 108.2f, 300.5f, 841.4f, 1051.8f, 1262.1f));
        /* 26 */casillas.add(new Estacion());
        /* 27 */casillas.add(new Solar(309.5f, 156.3f, 180.3f, 180.3f, 24f, 120.2f, 360.6f, 961.6f, 1202f, 1502.5f));
        /* 28 */casillas.add(new Solar(309.5f, 156.3f, 180.3f, 180.3f, 24f, 120.2f, 360.6f, 961.6f, 1202f, 1502.5f));
        /* 29 */casillas.add(new ServicioPublico());
        /* 30 */casillas.add(new Solar(333.3f, 168.3f, 180.3f, 180.3f, 24f, 144.2f, 450.8f, 1021.7f, 1352.3f, 1502.5f));
        
        /* 31 */casillas.add(new Esquina(4));
        
        /* 32 */casillas.add(new Solar(357.1f, 180.3f, 240.4f, 240.4f, 31.3f, 156.3f, 468.8f, 1081.8f, 1322.2f, 1502.5f));
        /* 33 */casillas.add(new Solar(357.1f, 180.3f, 240.4f, 240.4f, 31.3f, 156.3f, 468.8f, 1081.8f, 1322.2f, 1502.5f));
        /* 34 */casillas.add(new Comunidad());
        /* 35 */casillas.add(new Solar(380.9f, 192.3f, 240.4f, 240.4f, 33.7f, 180.3f, 540.9f, 1202f, 1442.4f, 1682.8f));
        /* 36 */casillas.add(new Estacion());
        /* 37 */casillas.add(new Suerte());
        /* 38 */casillas.add(new Solar(416.6f, 210.4f, 240.4f, 240.4f, 42.1f, 210.4f, 601f, 721.2f, 1562.6f, 1803f));
        /* 39 */casillas.add(new Penalizacion(119f));
        /* 40 */casillas.add(new Solar(476.1f, 240.4f, 240.4f, 240.4f, 60.1f, 240.4f, 721.2f, 1682.8f, 2043.4f, 2404f));
        
        // Asignacin de la propiedad del n de casilla
        for (int i = 0; i < 40; i++)
            casillas.get(i).setIdCasilla(i+1);
        
        // Asociar las casillas del mismo grupo de color
        asociar(1, 3, -1);
        asociar(6, 8, 9);
        asociar(11, 13, 14);
        asociar(16, 18, 19);
        asociar(21, 23, 24);
        asociar(26, 27, 29);
        asociar(31, 32, 34);
        asociar(37, 39, -1);
    
    }
    
    public void asociar(int a, int b, int c) {
        
        ((Solar)casillas.get(a)).getAsociados().add(((Solar)casillas.get(b)));
        ((Solar)casillas.get(b)).getAsociados().add(((Solar)casillas.get(a)));
        if (c >= 0)
        {
            ((Solar)casillas.get(a)).getAsociados().add(((Solar)casillas.get(c)));
            ((Solar)casillas.get(b)).getAsociados().add(((Solar)casillas.get(c)));
            ((Solar)casillas.get(c)).getAsociados().add(((Solar)casillas.get(a)));
            ((Solar)casillas.get(c)).getAsociados().add(((Solar)casillas.get(b)));
        }
        
    }
    
    
    public List<Casilla> getCasillas() {
        return casillas;
    }

    
}
