package uhupoly;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Tarjeta implements Serializable, Comparable {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="IDTarjeta")
    private Long id;
    
    private int numTarjeta;
    
    private String texto;

    @OneToOne(cascade=CascadeType.ALL)
    private Jugador propietario;
    
    public int compareTo(Object o) {
        return (numTarjeta - ((Tarjeta)o).numTarjeta);
    }
    
    /**
     * ######### PERSISTENCIA #####################
     */
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarjeta)) {
            return false;
        }
        Tarjeta other = (Tarjeta)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "Tarjeta";
        return res;
    }
    
     /**
     * ######### FIN PERSISTENCIA #####################
     */

    public Tarjeta() {
    }

    public String getTexto() {
        return texto;
    }

    public void setTexto(String val) {
        this.texto = val;
    }

    public Jugador getPropietario() {
        return propietario;
    }

    public void setPropietario(Jugador val) {
        this.propietario = val;
    }

    public int getNumTarjeta() {
        return numTarjeta;
    }

    public void setNumTarjeta(int numTarjeta) {
        this.numTarjeta = numTarjeta;
    }
}
